QwtPlotItem(3)

NAME
QwtPlotItem -

SYNOPSIS

#include <qwt_plot_item.h>

Inherits QwtLegendItemManager.

Inherited by QwtPlotAbstractSeriesItem, QwtPlotGrid, QwtPlotMarker, QwtPlotRasterItem, QwtPlotScaleItem, and QwtPlotSvgItem.

  Public Types
enum ItemAttribute { Legend = 0x01, AutoScale = 0x02 }
typedef QFlags< ItemAttribute > ItemAttributes
enum RenderHint { RenderAntialiased = 1 }
typedef QFlags< RenderHint > RenderHints
enum RttiValues { Rtti_PlotItem = 0, Rtti_PlotGrid, Rtti_PlotScale, Rtti_PlotMarker, Rtti_PlotCurve, Rtti_PlotSpectroCurve, Rtti_PlotIntervalCurve, Rtti_PlotHistogram, Rtti_PlotSpectrogram, Rtti_PlotSVG, Rtti_PlotUserItem = 1000 }

  Public Member Functions
QwtPlotItem (const QwtText &title=QwtText())
virtual ~QwtPlotItem ()
void attach (QwtPlot *plot)
virtual QRectF boundingRect () const
void detach ()
virtual void draw (QPainter *painter, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect) const =0
void hide ()
bool isVisible () const
virtual void itemChanged ()
virtual QWidget * legendItem () const
QRectF paintRect (const QwtScaleMap &, const QwtScaleMap &) const
QwtPlot * plot () const
virtual int rtti () const
QRectF scaleRect (const QwtScaleMap &, const QwtScaleMap &) const
void setAxes (int xAxis, int yAxis)
void setItemAttribute (ItemAttribute, bool on=true)
void setRenderHint (RenderHint, bool on=true)
void setTitle (const QString &title)
void setTitle (const QwtText &title)
virtual void setVisible (bool)
void setXAxis (int axis)
void setYAxis (int axis)
void setZ (double z)
void show ()
bool testItemAttribute (ItemAttribute) const
bool testRenderHint (RenderHint) const
const QwtText & title () const
virtual void updateLegend (QwtLegend *) const
virtual void updateScaleDiv (const QwtScaleDiv &, const QwtScaleDiv &)
int xAxis () const
int yAxis () const
double z () const

Detailed Description

Base class for items on the plot canvas. A plot item is 'something', that can be painted on the plot canvas, or only affects the scales of the plot widget. They can be categorized as:

•   Representator
     A 'Representator' is an item that represents some sort of data on the plot canvas. The different representator classes are organized according to the characteristics of the data:

•   QwtPlotMarker Represents a point or a horizontal/vertical coordinate

•   QwtPlotCurve Represents a series of points

•   QwtPlotSpectrogram ( QwtPlotRasterItem ) Represents raster data

•   ...

•   Decorators
     A 'Decorator' is an item, that displays additional information, that is not related to any data:

•   QwtPlotGrid

•   QwtPlotScaleItem

•   QwtPlotSvgItem

•   ...

Depending on the QwtPlotItem::ItemAttribute flags, an item is included into autoscaling or has an entry on the legnd.

Before misusing the existing item classes it might be better to implement a new type of plot item ( don't implement a watermark as spectrogram ). Deriving a new type of QwtPlotItem primarily means to implement the YourPlotItem::draw() method.

See also:
    The cpuplot example shows the implementation of additional plot items.

Member Enumeration Documentation

  enum QwtPlotItem::ItemAttribute
Plot Item Attributes

See also:
    setItemAttribute(), testItemAttribute()

Enumerator:

Legend
    The item is represented on the legend.

AutoScale
    The boundingRect() of the item is included in the autoscaling calculation.

  enum QwtPlotItem::RenderHint

Render hints.

Enumerator:

RenderAntialiased
    Enable antialiasing.

  enum QwtPlotItem::RttiValues

Runtime type information. RttiValues is used to cast plot items, without having to enable runtime type information of the compiler.

Enumerator:

Rtti_PlotItem
    Unspecific value, that can be used, when it doesn't matter.

Rtti_PlotGrid
    For QwtPlotGrid.

Rtti_PlotScale
    For QwtPlotScaleItem.

Rtti_PlotMarker
    For QwtPlotMarker.

Rtti_PlotCurve
    For QwtPlotCurve.

Rtti_PlotSpectroCurve
    For QwtPlotSpectroCurve.

Rtti_PlotIntervalCurve
    For QwtPlotIntervalCurve.

Rtti_PlotHistogram
    For QwtPlotHistogram.

Rtti_PlotSpectrogram
    For QwtPlotSpectrogram.

Rtti_PlotSVG
    For QwtPlotSvgItem.

Rtti_PlotUserItem
    Values >= Rtti_PlotUserItem are reserved for plot items not implemented in the Qwt library.

Constructor & Destructor Documentation

  QwtPlotItem::QwtPlotItem (const QwtText &title = QwtText()) [explicit]
Constructor

Parameters:
    title Title of the item

Member Function Documentation

  void QwtPlotItem::attach (QwtPlot *plot)

Attach the item to a plot. This method will attach a QwtPlotItem to the QwtPlot argument. It will first detach the QwtPlotItem from any plot from a previous call to attach (if necessary). If a NULL argument is passed, it will detach from any QwtPlot it was attached to.

Parameters:
    plot Plot widget

See also:
    detach()

  QRectF QwtPlotItem::boundingRect () const [virtual]
Returns:
    An invalid bounding rect: QRectF(1.0, 1.0, -2.0, -2.0)

Note:
    A width or height < 0.0 is ignored by the autoscaler

Reimplemented in QwtPlotSeriesItem< T >, QwtPlotSeriesItem< QwtIntervalSample >, QwtPlotSeriesItem< QPointF >, QwtPlotSeriesItem< QwtPoint3D >, QwtPlotIntervalCurve, QwtPlotMarker, QwtPlotRasterItem, QwtPlotHistogram, and QwtPlotSvgItem.

  void QwtPlotItem::detach ()

This method detaches a QwtPlotItem from any QwtPlot it has been associated with. detach() is equivalent to calling attach( NULL )

See also:
    attach()

  virtual void QwtPlotItem::draw (QPainter *painter, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect) const [pure virtual]

Draw the item. Parameters:
    painter Painter
    xMap Maps x-values into pixel coordinates.
    yMap Maps y-values into pixel coordinates.
    canvasRect Contents rect of the canvas in painter coordinates

Implemented in QwtPlotMarker, QwtPlotRasterItem, QwtPlotSpectrogram, QwtPlotScaleItem, QwtPlotGrid, QwtPlotSvgItem, and QwtPlotAbstractSeriesItem.

  bool QwtPlotItem::isVisible () const
Returns:
    true if visible

See also:
    setVisible(), show(), hide()

  void QwtPlotItem::itemChanged () [virtual]
Update the legend and call QwtPlot::autoRefresh for the parent plot.

See also:
    updateLegend()

  QWidget * QwtPlotItem::legendItem () const [virtual]

Allocate the widget that represents the item on the legend. The default implementation returns a QwtLegendItem(), but an item could be represented by any type of widget, by overloading legendItem() and updateLegend().

Returns:
    QwtLegendItem()

See also:
    updateLegend() QwtLegend()

Implements QwtLegendItemManager.

  QRectF QwtPlotItem::paintRect (const QwtScaleMap &xMap, const QwtScaleMap &yMap) const

Calculate the bounding paint rect of 2 maps. Parameters:
    xMap X map
    yMap Y map

Returns:
    Bounding paint rect of the scale maps, not normalized

  int QwtPlotItem::rtti () const [virtual]
Return rtti for the specific class represented. QwtPlotItem is simply a virtual interface class, and base classes will implement this method with specific rtti values so a user can differentiate them.

The rtti value is useful for environments, where the runtime type information is disabled and it is not possible to do a dynamic_cast<...>.

Returns:
    rtti value

See also:
    RttiValues

Reimplemented in QwtPlotCurve, QwtPlotIntervalCurve, QwtPlotSpectrogram, QwtPlotHistogram, QwtPlotMarker, QwtPlotScaleItem, QwtPlotSvgItem, QwtPlotSpectroCurve, and QwtPlotGrid.

  QRectF QwtPlotItem::scaleRect (const QwtScaleMap &xMap, const QwtScaleMap &yMap) const

Calculate the bounding scale rect of 2 maps. Parameters:
    xMap X map
    yMap Y map

Returns:
    Bounding scale rect of the scale maps, not normalized

  void QwtPlotItem::setAxes (intxAxis, intyAxis)
Set X and Y axis

The item will painted according to the coordinates its Axes.

Parameters:
    xAxis X Axis ( QwtPlot::xBottom or QwtPlot::xTop )
    yAxis Y Axis ( QwtPlot::yLeft or QwtPlot::yRight )

See also:
    setXAxis(), setYAxis(), xAxis(), yAxis(), QwtPlot::Axis

  void QwtPlotItem::setItemAttribute (ItemAttributeattribute, boolon = true)
Toggle an item attribute

Parameters:
    attribute Attribute type
    on true/false

See also:
    testItemAttribute(), ItemAttribute

  void QwtPlotItem::setRenderHint (RenderHinthint, boolon = true)
Toggle an render hint

Parameters:
    hint Render hint
    on true/false

See also:
    testRenderHint(), RenderHint

  void QwtPlotItem::setTitle (const QString &title)
Set a new title

Parameters:
    title Title

See also:
    title()

  void QwtPlotItem::setTitle (const QwtText &title)
Set a new title

Parameters:
    title Title

See also:
    title()

  void QwtPlotItem::setVisible (boolon) [virtual]
Show/Hide the item

Parameters:
    on Show if true, otherwise hide

See also:
    isVisible(), show(), hide()

  void QwtPlotItem::setXAxis (intaxis)
Set the X axis

The item will painted according to the coordinates its Axes.

Parameters:
    axis X Axis ( QwtPlot::xBottom or QwtPlot::xTop )

See also:
    setAxes(), setYAxis(), xAxis(), QwtPlot::Axis

  void QwtPlotItem::setYAxis (intaxis)
Set the Y axis

The item will painted according to the coordinates its Axes.

Parameters:
    axis Y Axis ( QwtPlot::yLeft or QwtPlot::yRight )

See also:
    setAxes(), setXAxis(), yAxis(), QwtPlot::Axis

  void QwtPlotItem::setZ (doublez)

Set the z value. Plot items are painted in increasing z-order.

Parameters:
    z Z-value

See also:
    z(), QwtPlotDict::itemList()

  bool QwtPlotItem::testItemAttribute (ItemAttributeattribute) const
Test an item attribute

Parameters:
    attribute Attribute type

Returns:
    true/false

See also:
    setItemAttribute(), ItemAttribute

  bool QwtPlotItem::testRenderHint (RenderHinthint) const
Test a render hint

Parameters:
    hint Render hint

Returns:
    true/false

See also:
    setRenderHint(), RenderHint

  const QwtText & QwtPlotItem::title () const
Returns:
    Title of the item

See also:
    setTitle()

  void QwtPlotItem::updateLegend (QwtLegend *legend) const [virtual]

Update the widget that represents the item on the legend. updateLegend() is called from itemChanged() to adopt the widget representing the item on the legend to its new configuration.

The default implementation updates a QwtLegendItem(), but an item could be represented by any type of widget, by overloading legendItem() and updateLegend().

Parameters:
    legend Legend

See also:
    legendItem(), itemChanged(), QwtLegend()

Implements QwtLegendItemManager.

Reimplemented in QwtPlotCurve, and QwtPlotMarker.

  void QwtPlotItem::updateScaleDiv (const QwtScaleDiv &xScaleDiv, const QwtScaleDiv &yScaleDiv) [virtual]

Update the item to changes of the axes scale division. Update the item, when the axes of plot have changed. The default implementation does nothing, but items that depend on the scale division (like QwtPlotGrid()) have to reimplement updateScaleDiv()

Parameters:
    xScaleDiv Scale division of the x-axis
    yScaleDiv Scale division of the y-axis

See also:
    QwtPlot::updateAxes()

Reimplemented in QwtPlotSeriesItem< T >, QwtPlotSeriesItem< QwtIntervalSample >, QwtPlotSeriesItem< QPointF >, QwtPlotSeriesItem< QwtPoint3D >, QwtPlotScaleItem, and QwtPlotGrid.

  double QwtPlotItem::z () const
Plot items are painted in increasing z-order.

Returns:
    setZ(), QwtPlotDict::itemList()

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.